<script setup lang="ts">
import { computed, reactive, ref } from 'vue'
import { email as emailValidator, required } from '@vuelidate/validators'
import { useRouter } from 'vue-router'
import UserApiV1 from '@/api/userApi'

const userData = reactive({
  username: '',
  email: '',
  name: '',
  surname_1: '',
  surname_2: '',
  role: null,
  password: '',
})

const saving = ref(false)
const isRequest = ref(false)
const isError = ref(false)
const requestMessage = ref('')

const isPasswordVisible = ref(false)
const isCPasswordVisible = ref(false)
const passwordValueNew = ref('')
const passwordValueConfirm = ref('')

const router = useRouter()

const alertToggleVariant = computed(() => isError.value ? 'error' : 'success')
const alertToggleText = computed(() => isError.value ? 'Error' : 'Success')

const rules = {
  required,
  email: emailValidator,
}

const optionsRole = ref([
  { value: null, title: 'Please select some item' },
  { value: 'USER', title: 'User' },
  { value: 'DEVELOPER', title: 'Developer' },
  { value: 'ADMIN', title: 'Administrator' },
  { value: 'ROOT', title: 'Root (SuperAdmin)' },
])

// Referencia al formulario para gestionar la validación
const form = ref(null)

async function validationForm() {
  if (form.value.validate())
    await saveUser()
}

async function saveUser() {
  saving.value = true

  const userApi = new UserApiV1()
  try {
    userData.password = passwordValueNew

    const response = await userApi.createUser(userData)

    requestMessage.value = response.data.message
    isError.value = false
    await router.push({ name: 'settings-users-list' })
  }
  catch (error) {
    console.error('Error creating user:', error)
    requestMessage.value = error.response.data.message
    isError.value = true
  }
  finally {
    saving.value = false
    isRequest.value = true
  }
}
</script>

<template>
  <VRow>
    <!-- 👉 Message Title and subtitle -->
    <VCol cols="12">
      <h6 class="text-h6 font-weight-medium">
        Create User
      </h6>
      <p class="mb-0">
        Enter User details for create the new user.
      </p>
    </VCol>
  </VRow>

  <VForm
    ref="form"
    class="mt-2"
  >
    <VContainer>
      <VRow>
        <VCol
          cols="12"
          md="6"
        >
          <VTextField
            v-model="userData.username"
            label="Username"
            :rules="[requiredValidator]"
            placeholder="Username"
            outlined
            dense
          />
        </VCol>
        <VCol
          cols="12"
          md="6"
        >
          <VTextField
            v-model="userData.email"
            label="Email"
            placeholder="Email"
            :rules="[requiredValidator, emailValidator]"
            type="email"
            outlined
            dense
          />
        </VCol>
        <VCol
          cols="12"
          md="6"
        >
          <VTextField
            v-model="userData.name"
            label="Name"
            placeholder="Name"
            outlined
            dense
          />
        </VCol>
        <VCol
          cols="12"
          md="6"
        >
          <VTextField
            v-model="userData.surname_1"
            label="Surname"
            placeholder="Surname"
            outlined
            dense
          />
        </VCol>
        <VCol
          cols="12"
          md="6"
        >
          <VTextField
            v-model="userData.surname_2"
            label="Second surname"
            placeholder="Second surname"
            outlined
            dense
          />
        </VCol>
        <VCol
          cols="12"
          md="6"
        >
          <VSelect
            v-model="userData.role"
            label="User role"
            :items="optionsRole"
            :rules="[rules.required]"
            outlined
            dense
          />
        </VCol>
        <!-- 👉 Message Title and subtitle -->
        <!-- 👉 :rules="[requiredValidator, passwordValidator]" -->
        <VCol
          cols="12"
          md="6"
        >
          <VTextField
            v-model="passwordValueNew"
            label="New Password"
            placeholder="············"
            :rules="[requiredValidator, passwordValidator]"
            :type="isPasswordVisible ? 'text' : 'password'"
            :append-inner-icon="isPasswordVisible ? 'tabler-eye-off' : 'tabler-eye'"
            outlined
            dense
            @click:append-inner="isPasswordVisible = !isPasswordVisible"
          />
        </VCol>
        <!-- 👉 Message Title and subtitle -->
        <VCol
          cols="12"
          md="6"
        >
          <VTextField
            v-model="passwordValueConfirm"
            label="Confirm Password"
            placeholder="············"
            :rules="[requiredValidator, confirmedValidator(passwordValueNew, passwordValueConfirm)]"
            :type="isCPasswordVisible ? 'text' : 'password'"
            :append-inner-icon="isCPasswordVisible ? 'tabler-eye-off' : 'tabler-eye'"
            outlined
            dense
            @click:append-inner="isCPasswordVisible = !isCPasswordVisible"
          />
        </VCol>

        <!-- 👉 Message Title and subtitle -->
        <VCol cols="12">
          <VAlert
            v-if="isRequest"
            border="start"
            :border-color="alertToggleVariant"
            :color="alertToggleVariant"
            :type="alertToggleVariant"
            variant="tonal"
            dense
            closable
          >
            <VIcon left>
              tabler-info-circle
            </VIcon>
            {{ alertToggleText }}: {{ requestMessage }}
          </VAlert>
        </VCol>

        <VCol cols="12">
          <VBtn
            color="primary"
            class="mt-2"
            :disabled="saving"
            @click="validationForm"
          >
            <VProgressCircular
              v-if="saving"
              indeterminate
              size="14"
            />
            <span v-if="saving">Saving...</span>
            <span v-else>Save changes</span>
          </VBtn>
        </VCol>
      </VRow>
    </VContainer>
  </VForm>
</template>

<style scoped>

</style>
